#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/resource.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/types.h>
#include <linux/input.h>

#define TRUE  1
#define FALSE 0

int key[8];
  int maxkey;
int                 RCtrl;     /* Remote Control file drescriptor */
int                 RCtrlCode; /* Remote Control KeyPressed */
struct input_event  RCevent;   /* Remote Control Event */
FILE               *outf;      /* kbd debug file */


int GetRCtrlCode(num)
     int num;
{
  int ret_val;
  
  ret_val = -1; /* No Event */
  
  if (read(key[num], &RCevent, sizeof(RCevent)) == sizeof(RCevent)){    
    switch(RCevent.type){
    case EV_SYN:
      break;
    case EV_KEY:
      ret_val = RCevent.value; /* 0 -> release, 1 -> press, 2 -> keep */

      fprintf(stderr, "Key   type code value : %02x, %03x, %d\n",
	      RCevent.type, RCevent.code, RCevent.value);
      break;
    default:
      fprintf(stderr, "Other type code value : %02x, %03x, %d\n",
	      RCevent.type, RCevent.code, RCevent.value);      
      /* Do nothing */
      break;
    }
  }
	
  return ret_val;
}


int
main(argc, argv)
     int argc;
     char *argv[];
{
  struct input_id device_info;
  int i;

  maxkey = 0;
  for(i=0; i< 8; i++){
    struct stat s;
    char tmp[128];

    sprintf(tmp, "/dev/input/event%d", i);
    if (stat(tmp, &s)) continue;

    /* open Remote Control */
    if ((key[i]=open(tmp, O_RDONLY|O_NONBLOCK)) != -1){
      maxkey++;
      if (ioctl(key[i], EVIOCGNAME(128), tmp) < 0) perror("EVIOCGNAME failed");

      fcntl(key[i], F_SETFL, fcntl(key[i], F_GETFL) | O_EXCL | O_NONBLOCK);
      
      fprintf(stderr,"input%d: %s", i, tmp);

      if(ioctl(key[i], EVIOCGID, &device_info)) perror("evdev ioctl");

      fprintf(stderr, " vendor %04hx product %04hx version %04hx\n",
	      device_info.vendor, device_info.product, 
	      device_info.version);
    }
  }

  i = 0;
  while(RCtrlCode != KEY_ESC){
    switch(GetRCtrlCode(i)){
    case 0: fprintf(stderr," Release Key(%d) : %d\n", i, RCtrlCode); break;
    case 1: fprintf(stderr,"   Press Key(%d) : %d\n", i, RCtrlCode); break;
    default: break;
    }
    i = (i+1)%maxkey;
  };

  for(i=0;i<maxkey;i++) close(key[i]);
  
  return 0;
}
